bug fixes for jessie & stretch
[automated-distro-installer] / fai / config / scripts / DEBIAN / 30-interface
index 12672f1ff4f7f18781c5e94e8038abb054383fe9..6f2251a1452ed9938cb468ca62e7099b22651988 100755 (executable)
@@ -3,11 +3,32 @@
 # modified from upstream fai example
 error=0; trap 'error=$(($?>$error?$?:$error))' ERR # save maximum error code
 
+if ! ifclass VM && ! ifclass STABLE; then
+    # get persistent interface name. Note, these class conditions
+    # will need to get modified for new oses. testing vm doesn't use
+    # it right now, but other vms do I'm sure.
+    for field in ID_NET_NAME_FROM_DATABASE \
+                     ID_NET_NAME_ONBOARD \
+                     ID_NET_NAME_SLOT \
+                     ID_NET_NAME_PATH \
+                     ID_NET_NAME_MAC; do
+        name=$(udevadm info /sys/class/net/$NIC1 | sed -rn "s/^E: $field=(.+)/\1/p")
+        if [[ $name ]]; then
+            NIC1=$name
+            break
+        fi
+    done
+    if [[ ! $name ]]; then
+        echo "$0: error: could not find systemd predictable network name"
+        exit 1
+    fi
+fi
+
 if ifclass DHCPC && [ $FAI_ACTION = "install" -o $FAI_ACTION = "dirinstall" ]
 then
     if ifclass VM; then
         cat > $target/etc/network/interfaces <<-EOF
-        # installed by FAI
+        # generated by FAI
         auto lo $NIC1
         iface lo inet loopback
         iface $NIC1 inet dhcp
@@ -40,7 +61,6 @@ then
           netmask $NETMASK
           broadcast $BROADCAST
           gateway $GATEWAYS
-          hwaddress ether $(cat /sys/class/net/$NIC1/address)
 EOF
     [ -n "$NETWORK" ] && echo "localnet $NETWORK" > $target/etc/networks
     if [ ! -L $target/etc/resolv.conf -a -e /etc/resolv.conf ]; then